setfenv(1, DockingStation)

CONFIG_IS_OPEN, UpdatePanelConfig, UpdatePluginConfig = false, DoNothing, DoNothing

if not select(2, GetAddOnInfo(configName)) then return end								-- Make sure the config module exists

ConfigFrames = {
	[0] = LibStub('LibOptionsAssist-0.0'):AddEntry(title, nil, configName),
	[1] = LibStub('LibOptionsAssist-0.0'):AddEntry("Panels", title, configName),
	[2] = LibStub('LibOptionsAssist-0.0'):AddEntry("Plugins", title, configName),
	[3] = LibStub('LibOptionsAssist-0.0'):AddEntry("Profiles", title, configName)
}
ConfigFrames[0]:SetAttribute('info', format("Version: %s", GetAddOnMetadata(title, 'Version')))

function OpenConfig()
	local open = 0
	for index = 0, #ConfigFrames do
		if ConfigFrames[index]:IsShown() then
			open = ConfigFrames[index]:IsVisible() and index + 1 or index
			break
		end
	end
	ConfigFrames[mod(open, #ConfigFrames + 1)]()
end

----------     Quicklauncher     ----------

LDB:NewDataObject(configName, {
	icon = format([[Interface\AddOns\%s\Media\Icon]], title),
	label = title,
	OnClick = OpenConfig,
	iconCoords = { 2/64, 61/64, 3/64, 61/64 },
	tooltiptext = format("Click to change %s's settings.", title),
	type = 'launcher'
})

----------     Slash Command     ----------

_G['SLASH_' .. title .. 1] = '/' .. title
_G['SLASH_' .. title .. 2] = '/' .. strlower(title)
_G['SLASH_' .. title .. 3] = '/' .. strupper(title)
SlashCmdList[title] = ConfigFrames[0]
