-- A modified version of StatusbarWidget.lua supplied with AceGUI-3.0-SharedMediaWidgets (by Yssaril)

local GUI, LSM = LibStub('AceGUI-3.0'), LibStub('LibSharedMedia-3.0')

local min, max, floor = min, max, floor
--local fixlevels = AceGUISharedMediaWidgets.fixlevels
local OnItemValueChanged = AceGUISharedMediaWidgets.OnItemValueChanged

local function SetText(self, text)
	if text and text ~= "" then
		self.texture:SetTexture(LSM:Fetch("overlay", text))
		self.texture:SetVertexColor(1, 1, 1, 1)
	else
		self.texture:SetVertexColor(0, 0, 0, 0)
	end
	self.text:SetText(text or "")
end
	
do
	local function Constructor()
		local self = GUI:Create('Dropdown-Item-Toggle')
		self.type = "LSM30_Overlay_Item_Select"
		self.SetText = SetText
		local bg = self.frame:CreateTexture(nil, 'BACKGROUND')
		bg:SetTexture([[Interface\BUTTONS\WHITE8X8]])
		bg:SetVertexColor(0.5, 0.5, 0.5)
		bg:SetPoint('TOPLEFT', self.frame, 'TOPLEFT', 6, -1)
		bg:SetPoint('BOTTOMRIGHT', self.frame, 'BOTTOMRIGHT', -4, 1)
		self.bg = bg
		local texture = self.frame:CreateTexture(nil, 'OVERLAY')
		texture:SetTexture([[Interface\BUTTONS\WHITE8X8]])
		texture:SetPoint('TOPLEFT', self.frame, 'TOPLEFT', 6, -1)
		texture:SetPoint('BOTTOMRIGHT', self.frame, 'BOTTOMRIGHT', -4, 1)
		self.texture = texture
		return self
	end
	GUI:RegisterWidgetType("LSM30_Overlay_Item_Select", Constructor, 1)
end

do 
	local function AddListItem(self, value, text)
		local item = GUI:Create("LSM30_Overlay_Item_Select")
		item:SetText(text)
		item.userdata.obj = self
		item.userdata.value = value
		item:SetCallback('OnValueChanged', OnItemValueChanged)
		self.pullout:AddItem(item)
	end
		
	local sortlist = { }
	local function SetList(self, list)
		self.list = list or LSM:HashTable("overlay")
		self.pullout:Clear()
		for v in pairs(self.list) do
			sortlist[#sortlist + 1] = v
		end
		table.sort(sortlist)
		for i, value in pairs(sortlist) do
			AddListItem(self, value, value)
			sortlist[i] = nil
		end
		if self.multiselect then
			AddCloseButton()
		end
	end
		
	local function Constructor()
		local self = GUI:Create('Dropdown')
		self.type = "LSM30_Overlay"
		self.SetText = SetText
		self.SetList = SetList
		self.SetValue = AceGUISharedMediaWidgets.SetValue

		local bgFrame = CreateFrame('Frame', nil, self.dropdown:GetParent())
		bgFrame:SetPoint('TOPLEFT', _G[self.dropdown:GetName() .. 'Left'], 'TOPLEFT', 24, -24)
		bgFrame:SetPoint('BOTTOMRIGHT', _G[self.dropdown:GetName() .. 'Right'], 'BOTTOMRIGHT', -39, 26)
		self.bgFrame = bgFrame

		local bg = bgFrame:CreateTexture(nil, 'BACKGROUND')
		bg:SetAllPoints(bgFrame)
		bg:SetTexture([[Interface\BUTTONS\WHITE8X8]])
		bg:SetVertexColor(0.5, 0.5, 0.5)
		self.bg = bg

		self.text:SetParent(bgFrame)

		local texture = bgFrame:CreateTexture(nil, 'OVERLAY')
		texture:SetAllPoints(bgFrame)
		self.texture = texture
		return self
	end
	GUI:RegisterWidgetType("LSM30_Overlay", Constructor, 1)
end

LSM.MediaList.overlay = LSM.MediaList.overlay or { }
LSM.MediaTable.overlay = LSM.MediaTable.overlay or { }
LSM.MediaType.OVERLAY = "overlay"
LSM.OverrideMedia.overlay = LSM.OverrideMedia.overlay or { }
AceGUIWidgetLSMlists.overlay = LSM:HashTable("overlay")
