local quixote = LibStub("LibQuixote-2.0")

function Inquest:InitializeTooltip()
	--self:HookScript(GameTooltip, "OnTooltipSetUnit", "GameTooltip_OnTooltipSetUnit")
	self:HookScript(GameTooltip, "OnTooltipSetItem", "GameTooltip_OnTooltipSetItem")
end

--Add tracker tooltips
function Inquest:LinkButton_OnEnter(linkButton)
	if(self.db.profile.trackerTooltip) then	
		GameTooltip:SetOwner(WatchFrame, "ANCHOR_CURSOR")
		if(linkButton.type == "QUEST") then
			GameTooltip:SetHyperlink(GetQuestLink(GetQuestIndexForWatch(linkButton.index)))
		elseif(linkButton.type == "ACHIEVEMENT") then
			GameTooltip:SetHyperlink(GetAchievementLink(linkButton.index))
		end
	end
end

--Add tooltips to mobs
function Inquest:GameTooltip_OnTooltipSetUnit()
	if(self.db.profile.questMobTooltip) then
		local name = GameTooltip:GetUnit()
		if(quixote:IsQuestMob(name)) then
			for k, v in quixote:IterateQuestsForMob(name) do
				local uid, qid, title = quixote:GetQuestByUid(v)
				if(uid) then
					for objName, numItem, numNeeded in quixote:IterateObjectivesForQuest(uid) do
						
						if(name == objName) then
							GameTooltip:AddDoubleLine(self:GetQuestLogTaggedTitle(qid), numItem .. "/" .. numNeeded, 0.8, 0.8, 0.8, 0.8, 0.8, 0.8)
						end
					end
				end
			end
		end
	end
end

--Add tooltips to quest items
function Inquest:GameTooltip_OnTooltipSetItem()
	if(self.db.profile.questItemTooltip) then
		local name = GameTooltip:GetItem()
		local uid, _, numItem, numNeeded = quixote:IsQuestItem(name)
		if(uid) then 
			local _, qid = quixote:GetQuestByUid(uid)
			GameTooltip:AddDoubleLine(self:GetQuestLogTaggedTitle(qid), numItem .. "/" .. numNeeded, nil, nil, nil, nil, nil, nil)
		end
	end
end
