local AddOn = CreateFrame("Frame")
local OnEvent = function(self, event, ...) self[event](self, event, ...) end

AddOn:SetScript("OnEvent", OnEvent)
AddOn:RegisterEvent("PLAYER_LOGIN")
AddOn:RegisterEvent("BAG_UPDATE")

AddOn.obj = LibStub("LibDataBroker-1.1"):NewDataObject("VertiBroker_Bags", { type = "data source" })

local function Update(self)
	local TotalBag, FreeBag, TakenBag = 0, 0, 0
	for Index = 0, 4 do
		local GetTotal = GetContainerNumSlots(Index)
		local GetFree = GetContainerNumFreeSlots(Index)
		if GetTotal and GetTotal > 0 then
			TotalBag = TotalBag + GetTotal
		end
		if GetFree and GetFree > 0 then
			FreeBag = FreeBag + GetFree
		end
	end
	TakenBag = TotalBag - FreeBag
	
	self.obj.text = "Bags: "..TakenBag.." / "..TotalBag
end

AddOn["PLAYER_LOGIN"] = Update
AddOn["BAG_UPDATE"] = Update

function AddOn.obj.OnClick(self, Button)
	if Button == "LeftButton" then
		ToggleBackpack()
	elseif Button == "RightButton" then
		ToggleKeyRing()
	end
end

function AddOn.obj.OnTooltipShow(Tooltip)
	Tooltip:AddLine("Bags:", 1, 1, 1)
	Tooltip:AddLine(" ")
	Tooltip:AddLine("Left Click to toggle the Backpack", 1, 1, 1)
	Tooltip:AddLine("Right Click to toggle the Key Ring", 1, 1, 1)
end 