local AddOn = CreateFrame("Frame")
local OnEvent = function(self, event, ...) self[event](self, event, ...) end

AddOn:SetScript("OnEvent", OnEvent)
AddOn:RegisterEvent("PLAYER_LOGIN")
AddOn:RegisterEvent("MINIMAP_UPDATE_TRACKING")

AddOn.obj = LibStub("LibDataBroker-1.1"):NewDataObject("VertiBroker_Tracking", { type = "data source", icon = "Interface\\Minimap\\Tracking\\None" })

local function Update(self)
	local IsActive = false
	for Index = 1, GetNumTrackingTypes() do
		local Name, Texture, Active = GetTrackingInfo(Index)
		if Active then
			IsActive = true
			self.obj.text = Name
			self.obj.icon = Texture
		end
	end
	if not IsActive then
		self.obj.text = "None"
		self.obj.icon = "Interface\\Minimap\\Tracking\\None"
	end
end

AddOn["PLAYER_LOGIN"] = Update
AddOn["MINIMAP_UPDATE_TRACKING"] = Update

function AddOn.obj.OnClick(self, Button)
	ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, self, 0, -1)
end

function AddOn.obj.OnTooltipShow(Tooltip)
	Tooltip:AddLine("Tracking:", 1, 1, 1)
	Tooltip:AddLine(" ")
	Tooltip:AddLine("Left Click to toggle the Tracking Menu", 1, 1, 1)
end 